Index: drivers/filesystems/btrfs/free-space.c
===================================================================
--- drivers/filesystems/btrfs/free-space.c	(révision 75772)
+++ drivers/filesystems/btrfs/free-space.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -21,20 +21,18 @@
 // this be a constant number of sectors, a constant 256 KB, or what?
 #define CACHE_INCREMENTS    64
 
-// #define DEBUG_SPACE_LISTS
-
 static NTSTATUS remove_free_space_inode(device_extension* Vcb, UINT64 inode, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     fcb* fcb;
-    
+
     Status = open_fcb(Vcb, Vcb->root_root, inode, BTRFS_TYPE_FILE, NULL, NULL, &fcb, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("open_fcb returned %08x\n", Status);
         return Status;
     }
-    
-    fcb->dirty = TRUE;
-    
+
+    mark_fcb_dirty(fcb);
+
     if (fcb->inode_item.st_size > 0) {
         Status = excise_extents(fcb->Vcb, fcb, 0, sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size), Irp, rollback);
         if (!NT_SUCCESS(Status)) {
@@ -42,13 +40,18 @@
             return Status;
         }
     }
-    
+
     fcb->deleted = TRUE;
-    
-    flush_fcb(fcb, FALSE, batchlist, Irp, rollback);
-    
-    free_fcb(fcb);
 
+    Status = flush_fcb(fcb, FALSE, batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("flush_fcb returned %08x\n", Status);
+        free_fcb(Vcb, fcb);
+        return Status;
+    }
+
+    free_fcb(Vcb, fcb);
+
     return STATUS_SUCCESS;
 }
 
@@ -58,48 +61,52 @@
     NTSTATUS Status;
     BOOL b;
     LIST_ENTRY rollback;
-    
+
     InitializeListHead(&rollback);
-    
+
     searchkey.obj_id = FREE_SPACE_CACHE_ID;
     searchkey.obj_type = 0;
     searchkey.offset = 0;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     do {
         if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type > searchkey.obj_type))
             break;
-        
+
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
-            delete_tree_item(Vcb, &tp, &rollback);
-            
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             if (tp.item->size >= sizeof(FREE_SPACE_ITEM)) {
                 FREE_SPACE_ITEM* fsi = (FREE_SPACE_ITEM*)tp.item->data;
-                
+
                 if (fsi->key.obj_type != TYPE_INODE_ITEM)
                     WARN("key (%llx,%x,%llx) does not point to an INODE_ITEM\n", fsi->key.obj_id, fsi->key.obj_type, fsi->key.offset);
                 else {
                     LIST_ENTRY* le;
-                    
+
                     Status = remove_free_space_inode(Vcb, fsi->key.obj_id, batchlist, Irp, &rollback);
-                    
+
                     if (!NT_SUCCESS(Status))
                         ERR("remove_free_space_inode for (%llx,%x,%llx) returned %08x\n", fsi->key.obj_id, fsi->key.obj_type, fsi->key.offset, Status);
-                    
+
                     le = Vcb->chunks.Flink;
                     while (le != &Vcb->chunks) {
                         chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
-                        
+
                         if (c->offset == tp.item->key.offset && c->cache) {
-                            free_fcb(c->cache);
+                            free_fcb(Vcb, c->cache);
                             c->cache = NULL;
                         }
-                        
+
                         le = le->Flink;
                     }
                 }
@@ -106,25 +113,82 @@
             } else
                 WARN("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_ITEM));
         }
-        
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
         if (b)
             tp = next_tp;
     } while (b);
-    
+
     Status = STATUS_SUCCESS;
-    
+
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
-    
+
+    if (Vcb->space_root) {
+        searchkey.obj_id = 0;
+        searchkey.obj_type = 0;
+        searchkey.offset = 0;
+
+        Status = find_item(Vcb, Vcb->space_root, &tp, &searchkey, FALSE, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("find_item returned %08x\n", Status);
+            return Status;
+        }
+
+        do {
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
+            b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
+            if (b)
+                tp = next_tp;
+        } while (b);
+    }
+
+    // regenerate free space tree
+    if (Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE) {
+        LIST_ENTRY* le;
+
+        ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+
+        le = Vcb->chunks.Flink;
+        while (le != &Vcb->chunks) {
+            chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+            if (!c->cache_loaded) {
+                ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+                Status = load_cache_chunk(Vcb, c, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("load_cache_chunk(%llx) returned %08x\n", c->offset, Status);
+                    ExReleaseResourceLite(&c->lock);
+                    ExReleaseResourceLite(&Vcb->chunk_lock);
+                    return Status;
+                }
+
+                c->changed = TRUE;
+                c->space_changed = TRUE;
+
+                ExReleaseResourceLite(&c->lock);
+            }
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+    }
+
     return Status;
 }
 
 NTSTATUS add_space_entry(LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 offset, UINT64 size) {
     space* s;
-    
+
     s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
     if (!s) {
@@ -134,59 +198,59 @@
 
     s->address = offset;
     s->size = size;
-    
+
     if (IsListEmpty(list))
         InsertTailList(list, &s->list_entry);
     else {
         space* s2 = CONTAINING_RECORD(list->Blink, space, list_entry);
-        
+
         if (s2->address < offset)
             InsertTailList(list, &s->list_entry);
         else {
             LIST_ENTRY* le;
-            
+
             le = list->Flink;
             while (le != list) {
                 s2 = CONTAINING_RECORD(le, space, list_entry);
-                
+
                 if (s2->address > offset) {
                     InsertTailList(le, &s->list_entry);
                     goto size;
                 }
-                
+
                 le = le->Flink;
             }
         }
     }
-    
+
 size:
     if (!list_size)
         return STATUS_SUCCESS;
-    
+
     if (IsListEmpty(list_size))
         InsertTailList(list_size, &s->list_entry_size);
     else {
         space* s2 = CONTAINING_RECORD(list_size->Blink, space, list_entry_size);
-        
+
         if (s2->size >= size)
             InsertTailList(list_size, &s->list_entry_size);
         else {
             LIST_ENTRY* le;
-            
+
             le = list_size->Flink;
             while (le != list_size) {
                 s2 = CONTAINING_RECORD(le, space, list_entry_size);
-                
+
                 if (s2->size <= size) {
                     InsertHeadList(le->Blink, &s->list_entry_size);
                     return STATUS_SUCCESS;
                 }
-                
+
                 le = le->Flink;
             }
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -194,7 +258,7 @@
     RTL_BITMAP bmph;
     UINT32 i, *dwords = data;
     ULONG runlength, index;
-    
+
     // flip bits
     for (i = 0; i < Vcb->superblock.sector_size / sizeof(UINT32); i++) {
         dwords[i] = ~dwords[i];
@@ -204,17 +268,17 @@
 
     index = 0;
     runlength = RtlFindFirstRunClear(&bmph, &index);
-            
+
     while (runlength != 0) {
         UINT64 addr, length;
-        
+
         addr = offset + (index * Vcb->superblock.sector_size);
         length = Vcb->superblock.sector_size * runlength;
-        
+
         add_space_entry(&c->space, &c->space_size, addr, length);
         index += runlength;
         *total_space += length;
-       
+
         runlength = RtlFindNextForwardRunClear(&bmph, index, &index);
     }
 }
@@ -221,25 +285,25 @@
 
 static void order_space_entry(space* s, LIST_ENTRY* list_size) {
     LIST_ENTRY* le;
-    
+
     if (IsListEmpty(list_size)) {
         InsertHeadList(list_size, &s->list_entry_size);
         return;
     }
-    
+
     le = list_size->Flink;
-    
+
     while (le != list_size) {
         space* s2 = CONTAINING_RECORD(le, space, list_entry_size);
-        
+
         if (s2->size <= s->size) {
             InsertHeadList(le->Blink, &s->list_entry_size);
             return;
         }
-        
+
         le = le->Flink;
     }
-    
+
     InsertTailList(list_size, &s->list_entry_size);
 }
 
@@ -250,37 +314,37 @@
 
 static NTSTATUS add_superblock_stripe(LIST_ENTRY* stripes, UINT64 off, UINT64 len) {
     UINT64 i;
-    
+
     for (i = 0; i < len; i++) {
         LIST_ENTRY* le;
         superblock_stripe* ss;
         BOOL ignore = FALSE;
-        
+
         le = stripes->Flink;
         while (le != stripes) {
             ss = CONTAINING_RECORD(le, superblock_stripe, list_entry);
-            
+
             if (ss->stripe == off + i) {
                 ignore = TRUE;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (ignore)
             continue;
-        
+
         ss = ExAllocatePoolWithTag(PagedPool, sizeof(superblock_stripe), ALLOC_TAG);
         if (!ss) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         ss->stripe = off + i;
         InsertTailList(stripes, &ss->list_entry);
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -288,17 +352,17 @@
     NTSTATUS Status;
     CHUNK_ITEM* ci = c->chunk_item;
     CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-    UINT64 off_start, off_end, space;
+    UINT64 off_start, off_end, space = 0;
     UINT16 i = 0, j;
     LIST_ENTRY stripes;
-    
+
     InitializeListHead(&stripes);
-    
+
     while (superblock_addrs[i] != 0) {
         if (ci->type & BLOCK_FLAG_RAID0 || ci->type & BLOCK_FLAG_RAID10) {
             for (j = 0; j < ci->num_stripes; j++) {
                 ULONG sub_stripes = max(ci->sub_stripes, 1);
-                
+
                 if (cis[j].offset + (ci->size * ci->num_stripes / sub_stripes) > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     off_start = superblock_addrs[i] - cis[j].offset;
                     off_start -= off_start % ci->stripe_length;
@@ -306,7 +370,7 @@
                     off_start += (j / sub_stripes) * ci->stripe_length;
 
                     off_end = off_start + ci->stripe_length;
-                    
+
                     Status = add_superblock_stripe(&stripes, off_start / ci->stripe_length, 1);
                     if (!NT_SUCCESS(Status)) {
                         ERR("add_superblock_stripe returned %08x\n", Status);
@@ -317,7 +381,7 @@
         } else if (ci->type & BLOCK_FLAG_RAID5) {
             for (j = 0; j < ci->num_stripes; j++) {
                 UINT64 stripe_size = ci->size / (ci->num_stripes - 1);
-                
+
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     off_start = superblock_addrs[i] - cis[j].offset;
                     off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 1));
@@ -335,7 +399,7 @@
         } else if (ci->type & BLOCK_FLAG_RAID6) {
             for (j = 0; j < ci->num_stripes; j++) {
                 UINT64 stripe_size = ci->size / (ci->num_stripes - 2);
-                
+
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     off_start = superblock_addrs[i] - cis[j].offset;
                     off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 2));
@@ -355,7 +419,7 @@
                 if (cis[j].offset + ci->size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     off_start = ((superblock_addrs[i] - cis[j].offset) / c->chunk_item->stripe_length) * c->chunk_item->stripe_length;
                     off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), c->chunk_item->stripe_length);
-                    
+
                     Status = add_superblock_stripe(&stripes, off_start / ci->stripe_length, (off_end - off_start) / ci->stripe_length);
                     if (!NT_SUCCESS(Status)) {
                         ERR("add_superblock_stripe returned %08x\n", Status);
@@ -364,142 +428,143 @@
                 }
             }
         }
-        
+
         i++;
     }
-    
-    space = 0;
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     while (!IsListEmpty(&stripes)) {
         LIST_ENTRY* le = RemoveHeadList(&stripes);
         superblock_stripe* ss = CONTAINING_RECORD(le, superblock_stripe, list_entry);
-        
+
         space++;
-        
+
         ExFreePool(ss);
     }
-    
+
     if (NT_SUCCESS(Status))
         *size = space * ci->stripe_length;
-    
+
     return Status;
 }
 
-static NTSTATUS load_stored_free_space_cache(device_extension* Vcb, chunk* c, PIRP Irp) {
+NTSTATUS load_stored_free_space_cache(device_extension* Vcb, chunk* c, BOOL load_only, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     FREE_SPACE_ITEM* fsi;
-    UINT64 inode, num_sectors, num_valid_sectors, i, *generation;
+    UINT64 inode, *generation;
     UINT8* data;
     NTSTATUS Status;
-    UINT32 *checksums, crc32;
+    UINT32 *checksums, crc32, i, num_sectors, num_valid_sectors, size;
     FREE_SPACE_ENTRY* fse;
-    UINT64 size, num_entries, num_bitmaps, extent_length, bmpnum, off, total_space = 0, superblock_size;
+    UINT64 num_entries, num_bitmaps, extent_length, bmpnum, off, total_space = 0, superblock_size;
     LIST_ENTRY *le, rollback;
-    
+
     // FIXME - does this break if Vcb->superblock.sector_size is not 4096?
-    
+
     TRACE("(%p, %llx)\n", Vcb, c->offset);
-    
+
     searchkey.obj_id = FREE_SPACE_CACHE_ID;
     searchkey.obj_type = 0;
     searchkey.offset = c->offset;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (keycmp(tp.item->key, searchkey)) {
         TRACE("(%llx,%x,%llx) not found\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
         return STATUS_NOT_FOUND;
     }
-    
+
     if (tp.item->size < sizeof(FREE_SPACE_ITEM)) {
         WARN("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_ITEM));
         return STATUS_NOT_FOUND;
     }
-    
+
     fsi = (FREE_SPACE_ITEM*)tp.item->data;
-    
+
     if (fsi->key.obj_type != TYPE_INODE_ITEM) {
         WARN("cache pointed to something other than an INODE_ITEM\n");
         return STATUS_NOT_FOUND;
     }
-    
+
     inode = fsi->key.obj_id;
     num_entries = fsi->num_entries;
     num_bitmaps = fsi->num_bitmaps;
-    
+
     Status = open_fcb(Vcb, Vcb->root_root, inode, BTRFS_TYPE_FILE, NULL, NULL, &c->cache, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("open_fcb returned %08x\n", Status);
         return STATUS_NOT_FOUND;
     }
-    
+
+    if (load_only)
+        return STATUS_SUCCESS;
+
     if (c->cache->inode_item.st_size == 0) {
         WARN("cache had zero length\n");
-        free_fcb(c->cache);
+        free_fcb(Vcb, c->cache);
         c->cache = NULL;
         return STATUS_NOT_FOUND;
     }
-    
+
     c->cache->inode_item.flags |= BTRFS_INODE_NODATACOW;
-    
+
     if (num_entries == 0 && num_bitmaps == 0)
         return STATUS_SUCCESS;
-    
-    size = sector_align(c->cache->inode_item.st_size, Vcb->superblock.sector_size);
-    
+
+    size = (UINT32)sector_align(c->cache->inode_item.st_size, Vcb->superblock.sector_size);
+
     data = ExAllocatePoolWithTag(PagedPool, size, ALLOC_TAG);
-    
+
     if (!data) {
         ERR("out of memory\n");
-        free_fcb(c->cache);
+        free_fcb(Vcb, c->cache);
         c->cache = NULL;
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    Status = read_file(c->cache, data, 0, c->cache->inode_item.st_size, NULL, NULL, FALSE);
+
+    Status = read_file(c->cache, data, 0, c->cache->inode_item.st_size, NULL, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("read_file returned %08x\n", Status);
         ExFreePool(data);
-        
+
         c->cache->deleted = TRUE;
         mark_fcb_dirty(c->cache);
-        
-        free_fcb(c->cache);
+
+        free_fcb(Vcb, c->cache);
         c->cache = NULL;
         return STATUS_NOT_FOUND;
     }
-    
+
     if (size > c->cache->inode_item.st_size)
-        RtlZeroMemory(&data[c->cache->inode_item.st_size], size - c->cache->inode_item.st_size);
-    
+        RtlZeroMemory(&data[c->cache->inode_item.st_size], (ULONG)(size - c->cache->inode_item.st_size));
+
     num_sectors = size / Vcb->superblock.sector_size;
-    
+
     generation = (UINT64*)(data + (num_sectors * sizeof(UINT32)));
-    
+
     if (*generation != fsi->generation) {
         WARN("free space cache generation for %llx was %llx, expected %llx\n", c->offset, *generation, fsi->generation);
         goto clearcache;
     }
-    
+
     extent_length = (num_sectors * sizeof(UINT32)) + sizeof(UINT64) + (num_entries * sizeof(FREE_SPACE_ENTRY));
-    
-    num_valid_sectors = (sector_align(extent_length, Vcb->superblock.sector_size) / Vcb->superblock.sector_size) + num_bitmaps;
-    
+
+    num_valid_sectors = (ULONG)((sector_align(extent_length, Vcb->superblock.sector_size) / Vcb->superblock.sector_size) + num_bitmaps);
+
     if (num_valid_sectors > num_sectors) {
         ERR("free space cache for %llx was %llx sectors, expected at least %llx\n", c->offset, num_sectors, num_valid_sectors);
         goto clearcache;
     }
-    
+
     checksums = (UINT32*)data;
-    
+
     for (i = 0; i < num_valid_sectors; i++) {
         if (i * Vcb->superblock.sector_size > sizeof(UINT32) * num_sectors)
             crc32 = ~calc_crc32c(0xffffffff, &data[i * Vcb->superblock.sector_size], Vcb->superblock.sector_size);
@@ -507,13 +572,13 @@
             crc32 = 0; // FIXME - test this
         else
             crc32 = ~calc_crc32c(0xffffffff, &data[sizeof(UINT32) * num_sectors], ((i + 1) * Vcb->superblock.sector_size) - (sizeof(UINT32) * num_sectors));
-        
+
         if (crc32 != checksums[i]) {
             WARN("checksum %llu was %08x, expected %08x\n", i, crc32, checksums[i]);
             goto clearcache;
         }
     }
-    
+
     off = (sizeof(UINT32) * num_sectors) + sizeof(UINT64);
 
     bmpnum = 0;
@@ -520,9 +585,9 @@
     for (i = 0; i < num_entries; i++) {
         if ((off + sizeof(FREE_SPACE_ENTRY)) / Vcb->superblock.sector_size != off / Vcb->superblock.sector_size)
             off = sector_align(off, Vcb->superblock.sector_size);
-        
+
         fse = (FREE_SPACE_ENTRY*)&data[off];
-        
+
         if (fse->type == FREE_SPACE_EXTENT) {
             Status = add_space_entry(&c->space, &c->space_size, fse->offset, fse->size);
             if (!NT_SUCCESS(Status)) {
@@ -530,35 +595,35 @@
                 ExFreePool(data);
                 return Status;
             }
-            
+
             total_space += fse->size;
         } else if (fse->type != FREE_SPACE_BITMAP) {
             ERR("unknown free-space type %x\n", fse->type);
         }
-                
+
         off += sizeof(FREE_SPACE_ENTRY);
     }
-    
+
     if (num_bitmaps > 0) {
         bmpnum = sector_align(off, Vcb->superblock.sector_size) / Vcb->superblock.sector_size;
         off = (sizeof(UINT32) * num_sectors) + sizeof(UINT64);
-        
+
         for (i = 0; i < num_entries; i++) {
             if ((off + sizeof(FREE_SPACE_ENTRY)) / Vcb->superblock.sector_size != off / Vcb->superblock.sector_size)
                 off = sector_align(off, Vcb->superblock.sector_size);
-            
+
             fse = (FREE_SPACE_ENTRY*)&data[off];
-            
+
             if (fse->type == FREE_SPACE_BITMAP) {
                 // FIXME - make sure we don't overflow the buffer here
                 load_free_space_bitmap(Vcb, c, fse->offset, &data[bmpnum * Vcb->superblock.sector_size], &total_space);
                 bmpnum++;
             }
-            
+
             off += sizeof(FREE_SPACE_ENTRY);
         }
     }
-    
+
     // do sanity check
 
     Status = get_superblock_size(c, &superblock_size);
@@ -567,48 +632,52 @@
         ExFreePool(data);
         return Status;
     }
-    
+
     if (c->chunk_item->size - c->used != total_space + superblock_size) {
         WARN("invalidating cache for chunk %llx: space was %llx, expected %llx\n", c->offset, total_space + superblock_size, c->chunk_item->size - c->used);
         goto clearcache;
     }
-    
+
     le = c->space.Flink;
     while (le != &c->space) {
         space* s = CONTAINING_RECORD(le, space, list_entry);
         LIST_ENTRY* le2 = le->Flink;
-        
+
         if (le2 != &c->space) {
             space* s2 = CONTAINING_RECORD(le2, space, list_entry);
-            
+
             if (s2->address == s->address + s->size) {
                 s->size += s2->size;
-                
+
                 RemoveEntryList(&s2->list_entry);
                 RemoveEntryList(&s2->list_entry_size);
                 ExFreePool(s2);
-                
+
                 RemoveEntryList(&s->list_entry_size);
                 order_space_entry(s, &c->space_size);
-                
+
                 le2 = le;
             }
         }
-        
+
         le = le2;
     }
-    
+
     ExFreePool(data);
-    
+
     return STATUS_SUCCESS;
-    
+
 clearcache:
     ExFreePool(data);
-    
+
     InitializeListHead(&rollback);
-    
-    delete_tree_item(Vcb, &tp, &rollback);
-    
+
+    Status = delete_tree_item(Vcb, &tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     Status = excise_extents(Vcb, c->cache, 0, c->cache->inode_item.st_size, Irp, &rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("excise_extents returned %08x\n", Status);
